/*global window, rJS, jIO, FormData */
/*jslint indent: 2, maxerr: 3 */


(function (window, rJS) {
  "use strict";

  function toNotebookModel(obj) {
    console.log(obj);
    return { "name": obj.value.title,
             // TODO: THIS PATH TO NOTEBOOK FILE
             "path": "foo/bar/notebook1.ipynb",
             //"path": "/localhost/Test-Notebook.ipynb",
             "type": "notebook",
             "format": "json",
             "writable": true,
             "last_modified": "2013-10-02T11:29:27.616675+00:00",
             "created": "2013-10-01T12:21:20.123456+00:00",
             "content": null
           };
  }

  function handleEvent(e) {
    this.jio_allDocs({
        query: 'portal_type: "Web JSON"',
        select_list : ['text_content', 'title', 'reference'], //, 'modification_date'], NOT WORKING
        // sort_on: [["modification_date", "descending"]], // NOT WORKING
        limit: [0, 5]
      })
      .push(function(result) {
        console.log("Querying Web JSON List");
        console.log(result.data.rows);
        var nbs = [];
        for(var i = 0; i < result.data.rows.length; i++) {
          nbs.push(toNotebookModel(result.data.rows[i]));
        }
        var root_dir = {"name": "",
                        "path": "",
                        "last_modified": "2017-09-06T03:33:29.781159Z",
                        "created": "2017-09-06T03:33:29.781159Z",
                        "content": nbs,
                       };
        console.log(root_dir);
        e.detail.resolve(root_dir);
      }, function(err) {
        e.detail.reject();
        console.log(err);
      });
  }

  rJS(window)
    .ready(function (gadget) {
      console.log("Jio Contents Gadget yes yes.");
      document.jiocontentsReady = true;
      return gadget;
    })
    .declareMethod('render', function (options) {

    })
    .declareAcquiredMethod("jio_allDocs", "jio_allDocs")
    .onEvent("custom_event", handleEvent, false, true);

}(window, rJS));

